#include <iostream>

using namespace std;

int nLeft,grid[11][11]={0};

void visit(int r,int c) {

  grid[r][c] = 0;
  nLeft--;

  if (grid[r-1][c])
    visit(r-1,c);
  if (grid[r+1][c])
    visit(r+1,c);
  if (grid[r][c-1])
    visit(r,c-1);
  if (grid[r][c+1])
    visit(r,c+1);
}

int main(void) {
  int n,m,t,r,c,i;
  char op;

  cin >> n >> m >> t >> op;
  nLeft = m;
  if (!cin)
    return 1;
  // n between 4 and 9
  if (n < 4 || n > 9)
    return 2;
  // m between 2 and 10
  if (m < 2 || m > 10)
    return 3;
  // t > 0
  if (t <= 0)
    return 4;
  // op is + - * /
  if (op != '+' && op != '-' && op != '*' && op != '/')
    return 5;

  for (i=0;i<m;i++) {
    cin >> r >> c;
    if (!cin)
      return 6;

    // r and c between 1 and n
    if (r <= 0 || r > n)
      return 7;
    if (c <= 0 || c > n)
      return 8;

    grid[r][c] = 1;
  }

  visit(r,c);
  if (nLeft != 0)
    return 9;

  // we win!
  return 42;
}

